/* error.c 502a */
#include "all.h"

jmp_buf errorjmp;

void
error(const char *fmt, ...)
{
    va_list va;

    print("error: ");
    va_start(va, fmt);
    vprint(fmt, va);
    va_end(va);
    print("\n");
    longjmp(errorjmp, 1);   
}
/* error.c 502b */
void
checkargc(Exp *e, int expected, int actual)
{
    if (expected != actual)
        error("expected %d but found %d argument%s in %e",
              expected, actual, actual == 1 ? "" : "s", e);
}
/* error.c 502c */
Name *duplicatename(Namelist *nl) 
{
    Name *n;
    Namelist *tail;
      
    if (nl != NULL) {
        n = nl->hd;
        for (tail = nl->tl; tail; tail = tail->tl)
            if (n == tail->hd)
                return n;
        return duplicatename(nl->tl);
    }
    return NULL;
}
