/* impcore.c 42a */
#include "all.h"

int
main(int argc, char *argv[])
{
    Funenv *functions;
    Valenv *globals;
    Topreader *input;
    int doprompt;

    doprompt = (argc <= 1) || (strcmp(argv[1], "-q") != 0);

    /* install conversion specifications in print module 43a */
    installprinter('d', printdecimal);
    installprinter('e', printexp);
    installprinter('E', printexplist);
    installprinter('f', printfun);
    installprinter('n', printname);
    installprinter('N', printnamelist);
    installprinter('p', printpar);
    installprinter('P', printparlist);
    installprinter('s', printstring);
    installprinter('t', printtoplevel);
    installprinter('v', printvalue);
    installprinter('V', printvaluelist);
    functions = mkFunenv(NULL, NULL);
    globals   = mkValenv(NULL, NULL);
    /* install the initial basis in [[functions]] 43b */
    {
        static char *prims[] = { "+", "-", "*", "/", "<", ">", "=", "print", 0 }
                                                                               ;
        char **p;
        Name *n;

        for (p=prims; *p; p++) {
            n = strtoname(*p);
            bindfun(n, mkPrimitive(n), functions);
        }
    }
    /* install the initial basis in [[functions]] 43d */
    {
        /* C representation of initial basis for {\impcore} */
        /* C representation of initial basis for {\impcore} */
        const char *basis=
            "(define and (b c) (if b c b))\n"
            "(define or  (b c) (if b b c))\n"
            "(define not (b)   (if b 0 1))\n"
            "(define <= (x y) (not (> x y)))\n"
            "(define >= (x y) (not (< x y)))\n"
            "(define != (x y) (not (= x y)))\n"
            "(define mod (m n) (- m (* n (/ m n))))\n";

        if (setjmp(errorjmp))
            assert(0); /* fail if error in basis */
        readevalprint(topreader(stringreader("intial basis", basis), 0),
                      globals, functions, 0);
    }

    input = topreader(filereader("standard input", stdin), doprompt);
    while (setjmp(errorjmp))
        ;
    readevalprint(input, globals, functions, 1);
    return 0;
}
