/* env.c 529c */
#include "all.h"
/* env.c 529d */
Value*
find(Name *name, Env *env)
{
    for (; env; env = env->tl)
        if (env->name == name)
            return env->loc;
    return NULL;
}
/* env.c 530a */
Env*
bindalloc(Name *name, Value val, Env *env)
{
    Env *newenv;

    newenv = malloc(sizeof(*newenv));
    assert(newenv != NULL);

    newenv->name = name;
    newenv->loc  = allocate(val);
    newenv->tl   = env;
    return newenv;
}
/* env.c 530b */
void
printenv(va_list *va) 
{
    Env *env;
    char *prefix;

    env = va_arg(*va, Env*);

    print("{");
    prefix = " ";
    for (; env; env = env->tl) {
        print("%s%n -> %v", prefix, env->name, *env->loc);
        prefix = ", ";
    }
    print(" }");
}
/* env.c 565b */
Env*
bindalloclist(Namelist *nl, Valuelist *vl, Env *env)
{
    pushroot(mkEnvroot(&env));
    for (; nl && vl; nl = nl->tl, vl = vl->tl)
        env = bindalloc(nl->hd, vl->hd, env);
    poproot(mkEnvroot(&env));
    return env;
}
/* env.c */
