/* name.c 44a */
#include "all.h"

struct Name {
    const char *s;
};
/* name.c 44b */
const char*
nametostr(Name *n)
{
    assert(n != NULL);
    return n->s;
}
/* name.c 44c */
Name*
strtoname(const char *s)
{
    static Namelist *names;
    Namelist *nl;
    Name *n;

    assert(s != NULL);
    for (nl=names; nl; nl=nl->tl)
        if (strcmp(s, nl->hd->s) == 0)
            return nl->hd;

    /* allocate a new name [[n]], add it to [[names]], and return it 44d */
    n = malloc(sizeof(*n));
    assert(n != NULL);
    n->s = malloc(strlen(s) + 1);
    assert(n->s != NULL);
    strcpy((char*)n->s, s);
    names = mkNL(n, names);
    return n;
}
/* name.c 45a */
void
printname(va_list *va)
{
    Name *n;

    n = va_arg(*va, Name*);
    if (n == NULL)
        print("<null>");
    else
        print("%s", nametostr(n));
}
