/* topeval.c 111d */
#include "all.h"
/* topeval.c 111e */
Env*
topeval(Toplevel *t, Env *env, int echo)
{
    switch (t->ty) {
    case EXP:
        /* evaluate top-level expression and return [[env]] 112a */
        if (echo)
            print("%v\n", eval(t->u.exp, env));
        else
            eval(t->u.exp, env);
        return env;
    case DEFINE:
        /* evaluate function definition and return new environment 112b */
        /* if [[t->u.define.lambda.formals]] contains a duplicate, call
                                                               [[error]] 538b */
        if (duplicatename(t->u.define.lambda.formals) != NULL)
            error(
               "formal parameter %n appears twice in definition of function %n",
                  duplicatename(t->u.define.lambda.formals), t->u.define.name);
        return topeval(mkVal(t->u.define.name, mkLambdax(t->u.define.lambda)),
                       env, echo);
    case VAL:
        /* evaluate [[val]] binding and return new environment 112c */
        {
            Value v;

            if (find(t->u.val.name, env) == NULL)
                env = bindalloc(t->u.val.name, mkNil(), env);
            v = eval(t->u.val.exp, env);
            *find(t->u.val.name, env) = v;
            if (echo) {
                if (t->u.val.exp->ty == LAMBDAX)
                    print("%n\n", t->u.val.name);
                else
                    print("%v\n", v);
            }
            return env;
        }
    case USE:
        /* read in a file and return new environment 113a */
        {
            FILE *fin;
            const char *filename;

            filename = nametostr(t->u.use);
            fin = fopen(filename, "r");
            if (fin == NULL)
                error("cannot open file \"%s\"", filename);
            readevalprint(topreader(filereader(filename, fin), 0), &env, 1);
            fclose(fin);
            return env;
        }
    default:
        assert(0);
        return NULL;
    }
}
/* topeval.c 113b */
void
readevalprint(Topreader *reader, Env **envp, int echo)
{
    Toplevel *t;

    while ((t = readtop(reader)))
        *envp = topeval(t, *envp, echo);
}
