#include "all.h"
Exp*
mkLiteral(Value x)
{
    Exp *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = LITERAL;
    n->u.literal = x;
    return n;
}

Exp*
mkVar(Name *x)
{
    Exp *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = VAR;
    n->u.var = x;
    return n;
}

Exp*
mkSet(Name *name, Exp *exp)
{
    Exp *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = SET;
    n->u.set.name = name;
    n->u.set.exp = exp;
    return n;
}

Exp*
mkIfx(Exp *cond, Exp *true, Exp *false)
{
    Exp *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = IFX;
    n->u.ifx.cond = cond;
    n->u.ifx.true = true;
    n->u.ifx.false = false;
    return n;
}

Exp*
mkWhilex(Exp *cond, Exp *exp)
{
    Exp *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = WHILEX;
    n->u.whilex.cond = cond;
    n->u.whilex.exp = exp;
    return n;
}

Exp*
mkBegin(Explist *x)
{
    Exp *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = BEGIN;
    n->u.begin = x;
    return n;
}

Exp*
mkApply(Name *name, Explist *actuals)
{
    Exp *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = APPLY;
    n->u.apply.name = name;
    n->u.apply.actuals = actuals;
    return n;
}

