/* Uninteresting implementations                */
/*                                              */
/* Of the uninteresting implementations, the    */
/* extensible printer is undoubtedly the most   */
/* interesting, even if it is the least         */
/* relevant to programming languages.           */
/*                                              */
/*   Printing                                   */
/* <print.c>=                                   */
#include "all.h"

static Printer *printertab[256];
/* <print.c>=                                   */
void
installprinter(unsigned char c, Printer *printer)
{
    printertab[c] = printer;
}
/* <print.c>=                                   */
void
print(const char *fmt, ...)
{
    va_list va;

    va_start(va, fmt);
    vprint(fmt, va);
    va_end(va);
    fflush(stdout);
}
/* <print.c>=                                   */






void
vprint(const char *fmt, va_list va)
{
    unsigned char *p;
    for (p = (unsigned char*)fmt; *p; p++) {
        if (*p != '%') {
            putchar(*p);
            continue;
        }
        if (printertab[*++p])
            printertab[*p](&va);
        else {
            printf("*%c*", *p);
            break;
        }
    }
}
/* <print.c>=                                   */
void
printpercent(va_list *va)
{
    (void)&va; /*UNIX*/

    putchar('%');
}
/* <print.c>=                                   */
void
printstring(va_list *va)
{
    const char *s;

    s = va_arg(*va, char*);
    if (s == NULL)
        printf("<null>");
    else
        printf("%s", s);
}
/* <print.c>=                                   */
void
printdecimal(va_list *va)
{
    printf("%d", va_arg(*va, int));
}
