#include "all.h"
Lambda
mkLambda(Namelist *formals, Exp *body)
{
    Lambda n;

    n.formals = formals;
    n.body = body;
    return n;
}

Value
mkNil(void)
{
    Value n;

    n.ty = NIL;
    return n;
}

Value
mkBool(int x)
{
    Value n;

    n.ty = BOOL;
    n.u.bool = x;
    return n;
}

Value
mkNum(int x)
{
    Value n;

    n.ty = NUM;
    n.u.num = x;
    return n;
}

Value
mkSym(Name *x)
{
    Value n;

    n.ty = SYM;
    n.u.sym = x;
    return n;
}

Value
mkPair(Value *car, Value *cdr)
{
    Value n;

    n.ty = PAIR;
    n.u.pair.car = car;
    n.u.pair.cdr = cdr;
    return n;
}

Value
mkClosure(Lambda lambda, Env *env)
{
    Value n;

    n.ty = CLOSURE;
    n.u.closure.lambda = lambda;
    n.u.closure.env = env;
    return n;
}

Value
mkPrimitive(int tag, Primitive *function)
{
    Value n;

    n.ty = PRIMITIVE;
    n.u.primitive.tag = tag;
    n.u.primitive.function = function;
    return n;
}

