;;;usm.nw:230
(class FinancialHistory Object
    (cashOnHand incomes expenditures)
    (method setInitialBalance: (amount)
         (set cashOnHand amount)
         (set incomes      (new Dictionary))
         (set expenditures (new Dictionary))
         self)
    (method receive:from: (amount source)
         (at:put: incomes source (+ (totalReceivedFrom: self source) amount))
         (set cashOnHand (+ cashOnHand amount)))
    (method spend:for: (amount reason)
         (at:put: expenditures reason (+ (totalSpentFor: self reason) amount))
         (set cashOnHand (- cashOnHand amount)))
    (method cashOnHand () cashOnHand)
    (method totalReceivedFrom: (source)
        (if (includesKey: incomes source)
            [(at: incomes source)]
            [0]))
    (method totalSpentFor: (reason)
        (if (includesKey: expenditures reason)
            [(at: expenditures reason)]
            [0]))
    (classMethod initialBalance: (amount)
         (setInitialBalance: (new self) amount))
)
;;;usm.nw:465
(class DeductibleHistory FinancialHistory
    (deductible)
    (classMethod initialBalance: (amount)
        (initDeductibleHistory (initialBalance: super amount)))
    (method initDeductibleHistory ()
        (set deductible 0)
        self)
    (method spend:deduct: (amount reason)
        (spend:for: self amount reason)
        (set deductible (+ deductible amount)))
    (method spend:for:deduct: (amount reason deduction)
        (spend:for: self amount reason)
        (set deductible (+ deductible deduction)))
    (method totalDeductions () deductible))
